//
//  main.m
//  Array
//
//  Created by Jiva DeVoe on 10/17/12.
//  Copyright (c) 2012 Pocket Lint Labs. All rights reserved.
//

#import <Foundation/Foundation.h>

int main(int argc, const char * argv[])
{

    @autoreleasepool
    {
        NSArray *array = @[@"foo", @"bar", @"baz"];
        
        NSLog(@"fast enumeration");
        for(NSString *item in array)
        {
            NSLog(@"%@", item);
        }
        
        NSLog(@"indexed access");
        
        for(NSInteger n = 0; n < [array count]; n++)
        {
            NSLog(@"%@", [array objectAtIndex:n]);
        }
        
        NSLog(@"new form indexed access");
        
        for(NSInteger n = 0; n < [array count]; n++)
        {
            NSLog(@"%@", array[n]);
        }
        
        NSLog(@"Last Object%@", [array lastObject]);
        
        NSLog(@"Index of object foo: %ld", [array indexOfObject:@"foo"]);
        
        
        NSRange range;
        range.location = 1;
        range.length = 2;
        NSIndexSet *indexSet = [NSIndexSet indexSetWithIndexesInRange:range];
        
        // this should get indexes for [@"bar", @"baz"]
        NSArray *subItems = [array objectsAtIndexes:indexSet];
        
        NSLog(@"subitems: %@", subItems);
        
        NSMutableArray *mutableArray = [array mutableCopy];
        
        [mutableArray addObject:@"boz"];
        NSLog(@"Now with more boz... %@", mutableArray);
        
        [mutableArray removeLastObject];
        NSLog(@"And now back to normal... %@", mutableArray);

        [mutableArray removeObjectAtIndex:1];
        NSLog(@"or is it? %@", mutableArray);
        
        [mutableArray sortUsingSelector:@selector(compare:)];
        NSLog(@"Sorted %@", mutableArray);
        
    }
    return 0;
}

