//
//  main.m
//  DictionaryInit
//
//  Created by Jiva DeVoe on 10/17/12.
//  Copyright (c) 2012 Pocket Lint Labs. All rights reserved.
//

#import <Foundation/Foundation.h>

int main(int argc, const char * argv[])
{

    @autoreleasepool
    {
        NSDictionary *dict = @{ @"one" : @"foo", @"two" : @"bar" , @"three" : @"baz" };

        NSLog(@"object for key");
        NSLog(@"%@", [dict objectForKey:@"one"]); // prints ‘foo’
        NSLog(@"%@", [dict objectForKey:@"two"]); // prints ‘bar’
        
        NSLog(@"subcript access");
        NSLog(@"%@", dict[@"one"]); // prints ‘foo’
        NSLog(@"%@", dict[@"two"]); // prints ‘bar’
        
        NSLog(@"Iterating the keys");
        for(NSString *key in dict)
        {
            NSLog(@"%@:%@", key, [dict objectForKey:key]);
        }
    
        NSLog(@"Using subscripting...");
        for(NSString *key in dict)
        {
            NSLog(@"%@:%@", key, dict[key]);
        }

        NSMutableDictionary *mutableDict = [dict mutableCopy];
        [mutableDict setObject:@"boz" forKey:@"four"];
        mutableDict[@"four"] = @"boz";
        
        NSLog(@"now you see boz: %@", mutableDict);
        
        [mutableDict removeObjectForKey:@"four"];

        NSLog(@"now you don't: %@", mutableDict);
    }
    return 0;
}

