//
//  main.m
//  Exceptions1
//
//  Created by Jiva DeVoe on 10/17/12.
//  Copyright (c) 2012 Pocket Lint Labs. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface FileMissingException : NSException
@end

@implementation FileMissingException
@end

@interface FilePermissionException : NSException
@end

@implementation FilePermissionException
@end

@interface FileWrapper : NSObject
-(void)openFileAtPath:(NSString *)inPath;
@end;

@implementation FileWrapper
{
    NSDictionary *contents;
}

-(BOOL)fileExistsAtPath:(NSString *)inPath
{
    return YES;
}

-(BOOL)hasPermissionForFileAtPath:(NSString *)inPath;
{
    return YES;
}

-(void)openFileAtPath:(NSString *)inPath;
{
    contents = [NSDictionary dictionaryWithContentsOfFile:inPath];
    if(!contents)
    {
        NSException *ex;
        if(![self fileExistsAtPath:inPath])
        {
            ex = [FileMissingException exceptionWithName:@"Error opening file"
                                                  reason:@"File doesn’t exist."
                                                userInfo:nil];
        }
        else if(![self hasPermissionForFileAtPath:inPath])
        {
            ex = [FilePermissionException exceptionWithName:@"Error opening file"
                                                     reason:@"Permission error."
                                                   userInfo:nil];
        } else
        {
            ex = [NSException exceptionWithName:@"Error opening file"
                                         reason:@"Unknown error."
                                       userInfo:nil];
        }
        @throw ex;
    }
}

@end


int main(int argc, const char * argv[])
{

    @autoreleasepool
    {
        @try
        {
            FileWrapper *wrapper = [[FileWrapper alloc] init];
            [wrapper openFileAtPath:@"..."];
            // do stuff with the file here...
        }
        @catch (FilePermissionException *e)
        {
            // ...
        }
        @catch (FileMissingException *e)
        {
            // ...
        }
        @catch (NSException *e)
        {
            // ...
        }
        @finally
        {
            // free up any resources you allocated...
        }
    }
    return 0;
}

