//
//  Mammal.m
//  Objects
//
//  Created by Jiva DeVoe on 10/16/12.
//  Copyright (c) 2012 Pocket Lint Labs. All rights reserved.
//

#import "Mammal.h"

@interface Mammal ()
-(BOOL)isMyBaby:(Mammal *)young;
-(void)feed:(Mammal *)young;
@end

@implementation Mammal

-(id)init
{
    return [self initWithFurColor:[NSColor brownColor]];
}
-(id)initWithFurColor:(NSColor *)furColor
{
    return [self initWithFurColor:furColor parent:nil];
}

-(id)initWithFurColor:(NSColor *)furColor parent:(Mammal *)parent
{
    if((self = [super init]))
    {
        _furColor = furColor;
        _parent = parent;
    }
    return self;
}

+(id)mammal
{
    return [[Mammal alloc] init];
}

-(void)vocalize
{
    NSLog(@"grunt");
}

-(NSArray *)giveLiveBirth
{
    return @[[Mammal new], [Mammal new], [Mammal new]];
}

-(void)nurseYoung:(Mammal *)young
{
    if([self isMyBaby:young])
    {
        [self feed:young];
    }
}

-(BOOL)isMyBaby:(Mammal *)young
{
    if([[young parent] isEqual:self])
    {
        return YES;
    }
    return NO;
}

-(void)feed:(Mammal *)young
{
    NSLog(@"Feeding young.");
}

@end
