//
//  main.m
//  Exceptions1
//
//  Created by Jiva DeVoe on 10/17/12.
//  Copyright (c) 2012 Pocket Lint Labs. All rights reserved.
//

#import <Foundation/Foundation.h>

void showErrorToUser(NSError *err)
{
    
}

@interface FileWrapper : NSObject
-(BOOL)openFileAtPath:(NSString *)inPath withError:( NSError **)outError;
@end;

@implementation FileWrapper
{
    NSDictionary *contents;
}

-(BOOL)fileExistsAtPath:(NSString *)inPath
{
    return YES;
}

-(BOOL)hasPermissionForFileAtPath:(NSString *)inPath;
{
    return YES;
}

-(BOOL)openFileAtPath:(NSString *)inPath withError:(NSError **)outError;
{
    contents = [NSDictionary dictionaryWithContentsOfFile:inPath];
    if(!contents)
    {
        if(![self fileExistsAtPath:inPath])
        {
            NSDictionary *errorInfo =
            [NSDictionary dictionaryWithObject:@"File doesn’t exist."
                                        forKey:NSLocalizedDescriptionKey];
            *outError = [NSError errorWithDomain:@"FileWrapper"
                                            code:404
                                        userInfo:errorInfo];
        }
        else if(![self hasPermissionForFileAtPath:inPath])
        {
            NSDictionary *errorInfo =
            [NSDictionary dictionaryWithObject:@"Permission Error."
                                        forKey:NSLocalizedDescriptionKey];
            *outError = [NSError errorWithDomain:@"FileWrapper"
                                            code:500
                                        userInfo:errorInfo];
            
        }
        else
        {
            NSDictionary *errorInfo =
            [NSDictionary dictionaryWithObject:@"Unknown error."
                                        forKey:NSLocalizedDescriptionKey];
            *outError = [NSError errorWithDomain:@"FileWrapper"
                                            code:501
                                        userInfo:errorInfo];}
        return NO;
    }
    return YES;
}
@end


int main(int argc, const char * argv[])
{
    
    @autoreleasepool
    {
        FileWrapper *wrapper = [[FileWrapper alloc] init];
    
        NSError *error = nil;
        if([wrapper openFileAtPath:@"..." withError:&error])
        {
            // do stuff with the file here...
        }
        else
        {
            // tell the user the file couldn’t be opened.
            // here you have the error object filled in.
            showErrorToUser(error);
        }
    }
    return 0;
}
























